﻿package com.HDI.loaders {
	
	import flash.display.Sprite;
	import flash.display.MovieClip;
	
	public class LdrBar extends MovieClip{
		//load status. I may need this later
		public var loadStat:Boolean;
		public function LdrBar():void{
			stop();
			init();
		}
		public function init():void{
			//On init, loader animation and bar size is reset.
			//The best part of use the init function instead of the
			//class method, is that I can call this anytime to reset the loader.
			ani.stop();
			bar.scaleX = 0.01;
		}
		public function ldrMon(perc:Number):void{
			//main loader animation control.
			//this method is called from the host using the progress event.
			//as the progress changes, the loader becomes visible and the animation plays.
			if(perc < 1){
				visible = true;
				bar.scaleX = perc;
				ani.play();
			}
			else{
				// when progress stops, loader becomes invisible and animation stops.
				ani.stop();
				visible =false;
				
			}
		}
	}
}