﻿package com.HDI.stage {
	/*import flash.display.Sprite;
	import flash.display.Stage;
	import flash.display.StageDisplayState;
	import flash.events.MouseEvent;
	import flash.geom.Rectangle;*/
	import flash.display.Stage;
	import flash.display.StageDisplayState;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.display.Loader;
	import flash.display.LoaderInfo;
	import flash.net.URLRequest;
	import flash.events.Event;
	import flash.events.ProgressEvent;
	import flash.display.MovieClip;
	
	public class SuperStage extends MovieClip {
		//External Variables:
		var fps:Number = 30;
		/* remove the variable definition from swfURL*/
		var swfURL:String;
		var ldrURL:String = "loaderbar.swf";
		
		//Loader Variables:
		var loadComplete:Boolean = false;
		var loadPerc:Number;
		var loaderCnt:Number = 0;
		
		//Internal Objects:
		var mainMovie:Object;
		var mainLdr:Object;
		var mainContainer:MovieClip;
		var loaderMC:MovieClip;
		
		public function SuperStage():void{
			init();
		}
		private function init():void{
			/* Add variable check here and use a default swf name if swfURL does not exist.*/
			if(loaderInfo.parameters.swfURL){
				swfURL = loaderInfo.parameters.swfURL;
			}
			else{
				swfURL = "sample.swf";
			}
			//Set all the stage properties onload
			stage.showDefaultContextMenu = false;
			stage.scaleMode = StageScaleMode.NO_SCALE;
			stage.align = StageAlign.TOP_LEFT;
			
			//load the main container and the loader container
			/*
			this is not manditory and can make things more complex,
			but so that the loader always stays on top, I add these to MovieClips
			then load everything else inside these clips.
			Load the loaderMC second so that it remains on top.
			*/
			mainContainer = new MovieClip();
			addChild(mainContainer);
			loaderMC = new MovieClip();
			addChild(loaderMC);
			
			//setup stage init incase I need it later.
			loaderInfo.addEventListener(Event.INIT,initStage);
			
			//start to load the loader bar.
			loadObject(loaderMC,ldrURL,null);
			stop();
		}
		function initStage(ev:Event):void{
			//stage.stageWidth = thisWidth;
			//stage.stageHeight = thisHeight;
		}
		//main loader method
		function loadObject(targ:Object,path:String,mon:Object):void{
			var ldr:Loader = new Loader();
			var ldrReq:URLRequest = new URLRequest(path);
			ldr.load(ldrReq);
			ldr.contentLoaderInfo.addEventListener(Event.COMPLETE, ldrFin);
			ldr.contentLoaderInfo.addEventListener(ProgressEvent.PROGRESS, ldrProgress);
			ldr.name = "ldr" + loaderCnt;
			targ.addChild(ldr);
			loaderCnt ++;
		}
		//finish loading. first two items loaded will be ldr0(loader bar) and ldr1(main content)
		function ldrFin(ev:Event):void{
			if(ev.target.loader.name == "ldr0"){
				mainLdr = ev.target.content;
				mainLdr.loadStat = true;
				mainLdr.x = (stage.stageWidth/2)-(mainLdr.width/2);
				mainLdr.y = (stage.stageHeight/2)-(mainLdr.height/2);
				loadObject(mainContainer,swfURL,mainLdr);
			}
			else if(ev.target.loader.name == "ldr1"){
				mainMovie = ev.target.content;
				stage.frameRate = ev.target.frameRate;
			}
		}
		//progress handler, sends loading info to loader bar.
		function ldrProgress(ev:ProgressEvent):void{
			if(mainLdr){
				mainLdr.ldrMon(ev.bytesLoaded/ev.bytesTotal);
			}
		}
	}
}